'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GroupNode = undefined;

var _exception = require('../exception');

var _ = require('./');

/**
 * Wraps the child expresison in parentheses to
 * provide higher precendence in evaulation.
 */
class GroupNode {
  /**
   * Initialise new GroupNode
   * @param {ExpNode} exp
   */
  constructor(exp) {
    this.exp = exp;
  }

  /**
   * Wrap and build child
   */
  build() {
    if (!(this.exp instanceof _.ExpNode)) {
      throw new _exception.InvalidGroupChildError('Only boolean expressions can be wrapped in parentheses.');
    }
    return `(${this.exp.build()})`;
  }
}
exports.GroupNode = GroupNode;